Ruby - Bug #13144

prettyprint doesn't detect cycles when wrapped inside Delegators
01/22/2017 01:49 AM - richardviney (Richard Viney)

Status: Closed
Priority: Normal
Assignee:

Target version:

ruby -v: 24.0 Backport: 2.2: UNKNOWN, 2.3: UNKNOWN, 2.4:
UNKNOWN

Description

The line count of the pretty print output for the following class grows factorially with the number of self-referencing SimpleDelegator
instances created by the initializer. With an n of 8 the line count of the pretty print output is almost one million! This occurs because
the cycle detection in lib/pp.rb doesn't detect the already printed object due to it being wrapped inside a Delegator instance. The
same problem occurs with pretty printing cycles wrapped inside WeakRef because it is a subclass of Delegator.

class Foo

def initialize(n)

n.times { |i| instance_variable_set "@a#{i}", SimpleDelegator.new(self) }
end

end

Associated revisions

Revision 6a75a460536a32fb62184dc5d8d66ddd737a9bad - 12/16/2019 02:43 PM - richardviney (Richard Viney)

Make prettyprint’s cycle detection aware of Delegator instances
Fixes [Bug #13144]

Co-Authored-By: Nobuyoshi Nakada nobu@ruby-lang.org

Revision 6a75a460536a32fb62184dc5d8d66ddd737a9bad - 12/16/2019 02:43 PM - richardviney (Richard Viney)

Make prettyprint’s cycle detection aware of Delegator instances
Fixes [Bug #13144]

Co-Authored-By: Nobuyoshi Nakada nobu@ruby-lang.org

Revision 6a75a460 - 12/16/2019 02:43 PM - richardviney (Richard Viney)

Make prettyprint’s cycle detection aware of Delegator instances
Fixes [Bug #13144]

Co-Authored-By: Nobuyoshi Nakada nobu@ruby-lang.org

History

#1 - 01/22/2017 01:57 AM - richardviney (Richard Viney)

Pull request with my fix and new test case: https://github.com/ruby/ruby/pull/1518

#2 - 12/16/2019 03:02 PM - richardviney (Richard Viney)
- Status changed from Open to Closed

Applied in changeset git|6a75a460536a32fb62184dc5d8d66ddd737a9bad.

Make prettyprint’s cycle detection aware of Delegator instances

Fixes [Bug #13144]

Co-Authored-By: Nobuyoshi Nakada nobu@ruby-lang.org
